/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/
package jp.co.ntt.lms.installer.lms;

import java.util.Iterator;
import java.util.Properties;
import java.util.logging.Logger;

import jp.co.ntt.lms.installer.core.InstallerAction;
import jp.co.ntt.lms.installer.core.InstallerActionValue;
import jp.co.ntt.lms.installer.core.InstallerException;
import jp.co.ntt.lms.installer.core.InstallerValues;
import jp.co.ntt.lms.installer.core.util.InstallerCheckUtil;
import jp.co.ntt.lms.installer.core.util.InstallerUiUtil;
import jp.co.ntt.lms.installer.util.LoggerUtil;

/**
 * データベースの初期化についてユーザに入力確認を求めるアクションクラス。<br>
 *
 * @author T.Nishiki
 */
public class ConfirmDbInitializeAction implements InstallerAction {
	/**
	 * ログ出力オブジェクト。
	 */
	private static Logger _logger;

	/**
	 * スタティック・イニシャライザ。
	 */
	static {
		_logger = LoggerUtil.getLogger(ConfirmDbInitializeAction.class);
	}

	/**
	 * アクションをスキップするか判定します。<br>
	 * スキップしません。常にfalseを戻します。
	 *
	 * @param values インストーラ共通データ・オブジェクト。
	 * @return 常にfalseを戻します。
	 */
	public boolean isSkipped(InstallerValues values) {
		return false;
	}

	/**
	 * データベースの初期化についてユーザに入力確認を求めます。<br>
	 *
	 * @param values インストーラ共通データ・オブジェクト。
	 * @return ConfirmDbInitializeValueオブジェクトを戻します。
	 * @throws InstallerException 実行中に例外が発生した場合。
	 * @see ConfirmDbInitializeValue
	 */
	public InstallerActionValue action(InstallerValues values)
			throws InstallerException {

		LoggerUtil.methodHead(_logger, "action(InstallerValues)");

		// 今回入力データ
		ConfirmDbInitializeValue inputValue = null;
		try {
			// タイトル表示
			InstallerUiUtil.outputMessageAsTitle(
				values, "ConfirmDbInitializeAction.welcome");

			while (true) {
				// 入力実行
				inputValue = readInputValue(values);
				// 入力確認
				if (confirmInputValue(values, inputValue) == true) {
					break;
				}
			}
		}
		catch (InstallerException e) {
			throw e;
		}
		catch (Exception e) {
			LoggerUtil.throwable(_logger, e);
			throw new InstallerException(e);
		}

		LoggerUtil.methodTail(_logger, "action(InstallerValues)", inputValue);
		return inputValue;
	}

	/**
	 * Temporary設定ファイルの書換項目について入力を求めます。<br>
	 *
	 * @param values インストーラ共通データ・オブジェクト。
	 * @return 入力された内容をConfirmDbInitializeValueとして戻します。
	 * @throws InstallerException 実行中に例外が発生した場合。
	 */
	private ConfirmDbInitializeValue readInputValue(InstallerValues values)
			throws InstallerException {
		LoggerUtil.methodHead(_logger,
			"readInputValue(InstallerValues)");

		ConfirmDbInitializeValue inputValue = null;
		try {
			inputValue = new ConfirmDbInitializeValue();
			// =================================================================
			// データベース初期化確認
			boolean confirmInitialize = InstallerUiUtil.askUserConfirm(
				values, "ConfirmDbInitializeAction.prompt.confirmInitialize" );
			inputValue.setConfirmInitialize(confirmInitialize);
			// =================================================================
			// データベース初期化を確認した場合、接続ユーザ／パスワードを入力
			if (confirmInitialize) {
				// =============================================================
				// データベース管理者ユーザ名称
				String dbaUser = null;
				while (true) {
					dbaUser = InstallerUiUtil.askUserInput(
						values, "ConfirmDbInitializeAction.prompt.dbaUser" );
					// 未入力
					if (InstallerCheckUtil.isEmptyViolation(
							dbaUser, values,
							"ConfirmDbInitializeAction.error.dbaUser.empty")) {
						continue;
					}
					break;
				}
				inputValue.setDbaUser(dbaUser);
				// =============================================================
				// データベース管理者ユーザ／パスワード
				String dbaPassword = InstallerUiUtil.askUserInput(
					values, "ConfirmDbInitializeAction.prompt.dbaPassword" );
				inputValue.setDbaPassword(dbaPassword);
				// =============================================================
				// データベース独自部分の入力
				String[] extendPropertiesNames
					= values.getDbExtendPropetyName();
				Properties extendProperties = new Properties();
				for (int i = 0; i < extendPropertiesNames.length; i++) {
					String extendPropertyName = extendPropertiesNames[i];
					String targetName = values.getMessage(extendPropertyName);
					Object[] messageParams = new Object[] {
						targetName
					};
					String extendPropertyValue
						= InstallerUiUtil.askUserInput(
							values, "db.extend.prompt", messageParams, null);
					extendProperties.setProperty(
						extendPropertyName, extendPropertyValue);
				}
				inputValue.setExtendProperties(extendProperties);
			}
		}
		catch (InstallerException e) {
			throw e;
		}
		catch (Exception e) {
			LoggerUtil.throwable(_logger, e);
			throw new InstallerException(e);
		}

		LoggerUtil.methodTail(_logger,
			"readInputValue(InstallerValues)", inputValue);
		return inputValue;
	}

	/**
	 * 入力した内容を表示し、ユーザに確認を求めます。<br>
	 * @param values インストーラ共通データ・オブジェクト。
	 * @param inputValue 入力された内容
	 * @return 入力された内容にユーザ確認がとれた場合true、
	 *          とれなかった場合falseを戻します。
	 * @throws InstallerException 処理中にエラーが発生した場合。
	 */
	private boolean confirmInputValue(
			InstallerValues values, ConfirmDbInitializeValue inputValue)
			throws InstallerException {

		LoggerUtil.methodHead(_logger,
			"confirmInputValue(InstallerValues, ConfirmDbInitializeValue)");
		boolean confirm = false;
		try {
			InstallerUiUtil.outputConfirmTitle(values,
				"ConfirmDbInitializeAction.confirm.title");
			// =================================================================
			// 入力内容の表示
			// =================================================================
			// データベース初期化確認
			InstallerUiUtil.outputConfirm(values,
				"ConfirmDbInitializeAction.confirm.confirmInitialize",
				InstallerUiUtil.convertBoolToConfirmString(
					inputValue.isConfirmInitialize()));
			// =================================================================
			// データベース初期化を確認した場合、接続ユーザ／パスワードを入力
			if (inputValue.isConfirmInitialize()) {
				// =============================================================
				// データベース管理者ユーザ名称
				InstallerUiUtil.outputConfirm(values,
					"ConfirmDbInitializeAction.confirm.dbaUser",
					inputValue.getDbaUser());
				// =============================================================
				// データベース管理者ユーザ／パスワード
				InstallerUiUtil.outputConfirm(values,
					"ConfirmDbInitializeAction.confirm.dbaPassword",
					inputValue.getDbaPassword());
			}
			// =================================================================
			// データベース独自部分の入力
			Properties extendProperties = inputValue.getExtendProperties();
			Iterator nameIterator = extendProperties.keySet().iterator();
			while (nameIterator.hasNext()) {
				String propertyNameKey = (String)nameIterator.next();
				String propertyValue
					= extendProperties.getProperty(propertyNameKey);
				InstallerUiUtil.outputConfirm(values,
					propertyNameKey, propertyValue);
			}
			// =================================================================
			// ユーザ確認
			confirm = InstallerUiUtil.askUserConfirm(
				values, "ConfirmDbInitializeAction.confirm" );
		}
		catch (Exception e) {
			LoggerUtil.throwable(_logger, e);
			throw new InstallerException(e);
		}

		LoggerUtil.methodTail(_logger,
			"confirmInputValue(InstallerValues, ConfirmDbInitializeValue)",
			confirm);
		return confirm;
	}
}
